---
title: Get AST for source code
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Security Monitoring
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Get AST for source code{% #get-ast-for-source-code %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                             |
| ----------------- | ---------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-ast |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-ast |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/static-analysis/static-analysis-server/get-ast      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/static-analysis/static-analysis-server/get-ast      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/static-analysis/static-analysis-server/get-ast  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-ast |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-ast     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-ast |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-ast |

### Overview

Parse source code into an abstract syntax tree (AST) for the specified language.

OAuth apps require the `code_analysis_read` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#security-monitoring) to access this endpoint.



### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                           | Type   | Description                                                                 |
| ------------ | ------------------------------- | ------ | --------------------------------------------------------------------------- |
|              | data [*required*]          | object | The primary data object in the get-AST request.                             |
| data         | attributes [*required*]    | object | The attributes of the get-AST request, containing the source code to parse. |
| attributes   | code [*required*]          | string | The base64-encoded source code to parse into an abstract syntax tree.       |
| attributes   | file_encoding [*required*] | string | The encoding of the source code file (must be utf-8).                       |
| attributes   | language [*required*]      | string | The programming language of the source code to parse.                       |
| data         | id                              | string | An optional identifier for the get-AST request resource.                    |
| data         | type [*required*]          | enum   | Get AST request resource type. Allowed enum values: `get_ast_request`       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "code": "aW1wb3J0IHN5cw==",
      "file_encoding": "utf-8",
      "language": "python"
    },
    "id": "string",
    "type": "get_ast_request"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
The response payload containing the parsed abstract syntax tree.

| Parent field | Field                        | Type   | Description                                                                         |
| ------------ | ---------------------------- | ------ | ----------------------------------------------------------------------------------- |
|              | data [*required*]       | object | The primary data object in the get-AST response.                                    |
| data         | attributes [*required*] | object | The attributes of the get-AST response, containing the parsed abstract syntax tree. |
| attributes   | ast [*required*]        | object | The parsed abstract syntax tree as a JSON object.                                   |
| data         | id                           | string | The identifier of the get-AST response resource.                                    |
| data         | type [*required*]       | enum   | Get AST response resource type. Allowed enum values: `get_ast_response`             |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "ast": {}
    },
    "id": "string",
    "type": "get_ast_response"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/static-analysis/static-analysis-server/get-ast" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "code": "aW1wb3J0IHN5cw==",
      "file_encoding": "utf-8",
      "language": "python"
    },
    "type": "get_ast_request"
  }
}
EOF 
                
##### 

```python
"""
Get AST for source code returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.security_monitoring_api import SecurityMonitoringApi
from datadog_api_client.v2.model.get_ast_request import GetAstRequest
from datadog_api_client.v2.model.get_ast_request_data import GetAstRequestData
from datadog_api_client.v2.model.get_ast_request_data_attributes import GetAstRequestDataAttributes
from datadog_api_client.v2.model.get_ast_request_data_type import GetAstRequestDataType

body = GetAstRequest(
    data=GetAstRequestData(
        attributes=GetAstRequestDataAttributes(
            code="aW1wb3J0IHN5cw==",
            file_encoding="utf-8",
            language="python",
        ),
        type=GetAstRequestDataType.GET_AST_REQUEST,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_static_analysis_ast"] = True
with ApiClient(configuration) as api_client:
    api_instance = SecurityMonitoringApi(api_client)
    response = api_instance.create_static_analysis_ast(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Get AST for source code returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_static_analysis_ast".to_sym] = true
end
api_instance = DatadogAPIClient::V2::SecurityMonitoringAPI.new

body = DatadogAPIClient::V2::GetAstRequest.new({
  data: DatadogAPIClient::V2::GetAstRequestData.new({
    attributes: DatadogAPIClient::V2::GetAstRequestDataAttributes.new({
      code: "aW1wb3J0IHN5cw==",
      file_encoding: "utf-8",
      language: "python",
    }),
    type: DatadogAPIClient::V2::GetAstRequestDataType::GET_AST_REQUEST,
  }),
})
p api_instance.create_static_analysis_ast(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Get AST for source code returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.GetAstRequest{
		Data: datadogV2.GetAstRequestData{
			Attributes: datadogV2.GetAstRequestDataAttributes{
				Code:         "aW1wb3J0IHN5cw==",
				FileEncoding: "utf-8",
				Language:     "python",
			},
			Type: datadogV2.GETASTREQUESTDATATYPE_GET_AST_REQUEST,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateStaticAnalysisAst", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSecurityMonitoringApi(apiClient)
	resp, r, err := api.CreateStaticAnalysisAst(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SecurityMonitoringApi.CreateStaticAnalysisAst`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `SecurityMonitoringApi.CreateStaticAnalysisAst`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Get AST for source code returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SecurityMonitoringApi;
import com.datadog.api.client.v2.model.GetAstRequest;
import com.datadog.api.client.v2.model.GetAstRequestData;
import com.datadog.api.client.v2.model.GetAstRequestDataAttributes;
import com.datadog.api.client.v2.model.GetAstRequestDataType;
import com.datadog.api.client.v2.model.GetAstResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createStaticAnalysisAst", true);
    SecurityMonitoringApi apiInstance = new SecurityMonitoringApi(defaultClient);

    GetAstRequest body =
        new GetAstRequest()
            .data(
                new GetAstRequestData()
                    .attributes(
                        new GetAstRequestDataAttributes()
                            .code("aW1wb3J0IHN5cw==")
                            .fileEncoding("utf-8")
                            .language("python"))
                    .type(GetAstRequestDataType.GET_AST_REQUEST));

    try {
      GetAstResponse result = apiInstance.createStaticAnalysisAst(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SecurityMonitoringApi#createStaticAnalysisAst");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Get AST for source code returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_security_monitoring::SecurityMonitoringAPI;
use datadog_api_client::datadogV2::model::GetAstRequest;
use datadog_api_client::datadogV2::model::GetAstRequestData;
use datadog_api_client::datadogV2::model::GetAstRequestDataAttributes;
use datadog_api_client::datadogV2::model::GetAstRequestDataType;

#[tokio::main]
async fn main() {
    let body = GetAstRequest::new(GetAstRequestData::new(
        GetAstRequestDataAttributes::new(
            "aW1wb3J0IHN5cw==".to_string(),
            "utf-8".to_string(),
            "python".to_string(),
        ),
        GetAstRequestDataType::GET_AST_REQUEST,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateStaticAnalysisAst", true);
    let api = SecurityMonitoringAPI::with_config(configuration);
    let resp = api.create_static_analysis_ast(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Get AST for source code returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createStaticAnalysisAst"] = true;
const apiInstance = new v2.SecurityMonitoringApi(configuration);

const params: v2.SecurityMonitoringApiCreateStaticAnalysisAstRequest = {
  body: {
    data: {
      attributes: {
        code: "aW1wb3J0IHN5cw==",
        fileEncoding: "utf-8",
        language: "python",
      },
      type: "get_ast_request",
    },
  },
};

apiInstance
  .createStaticAnalysisAst(params)
  .then((data: v2.GetAstResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
